////////////////////////////////////////////////////////////////////////////////
// When the class is inside a namespace Doxygen raises the warning:
// enum.cpp:24: warning: member `operator EnumNamespace::EnumInsideClass' of
// class `EnumClass' cannot be found
////////////////////////////////////////////////////////////////////////////////

namespace EnumNamespace {

/// This class has an enum inside it.
class EnumClass
{

public:

   /// Enum inside a class.
   enum EnumInsideClass
   {
      TypeA, ///< This is type A
      TypeB, ///< This is type B
      TypeC ///< This is type C
   };

   /// Cast EnumClass to EnumInsideClass.
   operator EnumInsideClass () const;

};

}

EnumNamespace::EnumClass::operator EnumNamespace::EnumClass::EnumInsideClass () const {}

////////////////////////////////////////////////////////////////////////////////
// No warning is raised when the class is not in a namespace.
////////////////////////////////////////////////////////////////////////////////

/// This class also has an enum inside it.
class NoNamespaceEnumClass
{

public:

   /// Another enum inside a class.
   enum EnumInsideClass
   {
      TypeA, ///< This is another type A
      TypeB, ///< This is another type B
      TypeC ///< This is another type C
   };

   /// Cast NoNamespaceEnumClass to EnumInsideClass.
   operator EnumInsideClass () const;

};

NoNamespaceEnumClass::operator NoNamespaceEnumClass::EnumInsideClass () const {}
